# ManifestTask

Extends \Task

ManifestTask

Generates a simple Manifest file with optional checksums.

Manifest schema: ... path/to/file CHECKSUM [CHECKSUM2] [CHECKSUM3] path/to/secondfile CHECKSUM [CHECKSUM2] [CHECKSUM3] ...

Example usage:

author | David Persson <davidpersson at qeweurope dot org>
package | phing.tasks.ext
since | 2.3.1

### Methods

## Nested adder, adds a set of files (nested fileset attribute).

    addFileSet(\FileSet $fs) : void

### Arguments

#### $fs

`\FileSet`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Wrapper method for hash generation Automatically selects extension Falls back to built-in functions

    hash(string $msg, string $algo) : mixed

link | http://www.php.net/mhash http://www.php.net/hash

### Arguments

#### $msg

`string`

The string that should be hashed

#### $algo

`string`

Algorithm

### Response

`mixed`

String on success, false if $algo is not available

## Hash a file's contents

    hashFile(string $file, string $algo) : mixed

### Arguments

#### $file

`string`

#### $algo

`string`

### Response

`mixed`

String on success, false if $algo is not available

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## read

    read()

todo | implement

## The setter for the attribute "checksum"

    setChecksum(mixed $mixed) : void

### Arguments

#### $mixed

`mixed`

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## The setter for the attribute "file".

    setFile(\PhingFile $file) : void

This is where the manifest will be written to/read from

### Arguments

#### $file

`\PhingFile`

Path to readable file

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## The setter for the optional attribute "salt"

    setSalt(string $string) : void

### Arguments

#### $string

`string`

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Validates attributes coming in from XML

    validateAttributes() : void

throws |

## Creates Manifest file Writes to $this->file

    write()

throws |

### Properties

## taskname

    taskname :

### Type(s)

``

## Action

    action : string

"w" for reading in files from fileSet and writing manifest

or

"r" for reading in files from fileSet and checking against manifest

var | "r" or "w"

### Type(s)

`string`

## The target file passed in the buildfile.

    destFile :

### Type(s)

``

## Holds filesets

    filesets : array

var | An Array of objects

### Type(s)

`array`

## Enable/Disable checksuming or/and select algorithm true defaults to md5 false disables checksuming string "md5,sha256,.

    checksum : boolean|string

.." enables generation of multiple checksums string "sha256" generates sha256 checksum only

var |

### Type(s)

`boolean|string`

## A string used in hashing method

    salt : string

var |

### Type(s)

`string`

## Holds some data collected during runtime

    meta : array

var |

### Type(s)

`array`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`